CREATE OR REPLACE 
PROCEDURE Transaksi_Cash(pNoRek TblTransaksi.NoRek1%TYPE,
                         pBesar TblTransaksi.Besar%TYPE)
IS
  cnt_norek INTEGER;
BEGIN
   IF (pNoRek IS NULL) THEN
       RAISE_APPLICATION_ERROR(-20000,'No Rekening tidak boleh kosong');
   END IF;
   IF (pBesar IS NULL) OR (pBesar<=0) THEN
       RAISE_APPLICATION_ERROR(-20001,'Besar transaksi harus lebih dari 0');
   END IF;
   SELECT count(*) INTO cnt_norek FROM TblTabungan WHERE NoRek=pNoRek;
   IF cnt_norek<>1 THEN
       RAISE_APPLICATION_ERROR(-20002,'No Rekening tidak ditemukan');
   END IF;
   INSERT INTO TblTransaksi
      VALUES(SeqNoTransaksi.NEXTVAL,SYSDATE,'C',pNoRek,pBesar,NULL);
   COMMIT;
END;
