CREATE OR REPLACE 
PROCEDURE Transaksi_Transfer(pNoRek1 TblTransaksi.NoRek1%TYPE,
                             pNoRek2 TblTransaksi.NoRek2%TYPE,
                             pBesar TblTransaksi.Besar%TYPE)
IS
  cnt_norek INTEGER;
  saldorek1 TblTabungan.Saldo%TYPE;
BEGIN
   IF (pNoRek1 IS NULL) THEN
       RAISE_APPLICATION_ERROR(-20000,'No Rekening pengirim tidak boleh kosong');
   END IF;
   IF (pNoRek2 IS NULL) THEN
       RAISE_APPLICATION_ERROR(-20001,'No Rekening penerima tidak boleh kosong');
   END IF;
   IF (pBesar IS NULL) OR (pBesar<=0) THEN
       RAISE_APPLICATION_ERROR(-20002,'Besar transaksi harus lebih dari 0');
   END IF;
   SELECT count(*) INTO cnt_norek FROM TblTabungan WHERE NoRek=pNoRek1;
   IF cnt_norek<>1 THEN
       RAISE_APPLICATION_ERROR(-20003,'No Rekening tidak ditemukan');
   ELSE
       SELECT Saldo INTO saldorek1 FROM TblTabungan WHERE NoRek=pNoRek1;
       IF saldorek1<pBesar THEN
          RAISE_APPLICATION_ERROR(-20004,'Saldo Pengirim tidak cukup. Tersedia Rp. '||saldorek1);
       END IF;
   END IF;
   SELECT count(*) INTO cnt_norek FROM TblTabungan WHERE NoRek=pNoRek2;
   IF cnt_norek<>1 THEN
       RAISE_APPLICATION_ERROR(-20005,'No Rekening penerima tidak ditemukan');
   END IF;
   INSERT INTO TblTransaksi
      VALUES(SeqNoTransaksi.NEXTVAL,SYSDATE,'T',pNoRek1,pBesar,pNoRek2);
   COMMIT;
END;
